<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Mpdf\Mpdf;

class GrupoDeCompra extends Model
{
  public $timestamps = false;
  protected $fillable = [ "nombre","region","telefono","correo","referente_finanzas","cantidad_de_nucleos"];
  protected $table = 'grupos_de_compra';
  protected $hidden = ['password'];

  public function subpedidos() {
  	return $this->hasMany('App\Subpedido');
  }

  public function exportarPlanillasAPdf() {
      $subpedidos = $this->subpedidos;
      //generar pdf
      $mpdf = new Mpdf();;
      foreach ($subpedidos as $subpedido) {
          $tabla = $subpedido->generarHTML();
          // agregar la tabla al pdf en una nueva página
          $mpdf->WriteHTML($tabla);
          $mpdf->AddPage();
      }
      // imprimir el pdf
      $mpdf->Output();
  }

}
